/**********************BST-V51ʵ鿪************************
*  ƽ̨BST-V51 + Keil U3 + STC89C52
*  ƣ8*8ģʵ
*  ˾ǲܿƼ޹˾       
*  ڣ2015-7
*  :11.0592MHZ
*  ʵЧʾ״
******************************************************************/
#include <reg52.h>
#include <intrins.h>
#include <string.h>

#define uchar unsigned char
#define uint  unsigned int
//Max7219˿
sbit Max7219_pinCLK = P2^5;//CLK
sbit Max7219_pinCS  = P1^1;//CS
sbit Max7219_pinDIN = P1^0;//DIN
sbit LED = P1^2; 


uchar disp1[8]=
{0x00,0x6C,0x92,0x82,0x44,0x28,0x10,0x00};//

/*Э鶨*/
bit startBit = 0;  				//ڽտʼ־λ
bit newLineReceived = 0; 		//һ֡Э
unsigned char inputString[50];  //Э
//ڳʼ
void ComInit(void)
{
   
   	SCON = 0x50; 	// SCON: ģʽ1, 8-bit UART, ʹܽ
	TMOD |= 0x20;
	TH1=0xfd; 		//9600 ֵ
	TL1=0xfd;
	TR1= 1;
	EA = 1;	    	//ж
	ES= 1; 			//򿪴ж
}

void Delay_xms(uint x)
{
 uint i,j;
 for(i=0;i<x;i++)
  for(j=0;j<112;j++);
}
//--------------------------------------------
//ܣMAX7219(U3)дֽ
//ڲDATA 
//ڲ
//˵
void Write_Max7219_byte(uchar DATA)         
{
    	uchar i;    
		Max7219_pinCS=0;		
	    for(i=8;i>=1;i--)
          {		  
            Max7219_pinCLK=0;
            Max7219_pinDIN=DATA&0x80;
            DATA=DATA<<1;
            Max7219_pinCLK=1;
           }                                 
}
//-------------------------------------------
//ܣMAX7219д
//ڲaddressdat
//ڲ
//˵
void Write_Max7219(uchar address,uchar dat)
{ 
     Max7219_pinCS=0;
	 Write_Max7219_byte(address);           //дַܱ
     Write_Max7219_byte(dat);               //дݣʾ 
	 Max7219_pinCS=1;                        
}

void Init_MAX7219(void)
{
	Write_Max7219(0x09, 0x00);       //뷽ʽBCD
	Write_Max7219(0x0a, 0x03);       // 
	Write_Max7219(0x0b, 0x07);       //ɨޣ8ʾ
	Write_Max7219(0x0c, 0x01);       //ģʽ0ͨģʽ1
	Write_Max7219(0x0f, 0x00);       //ʾԣ1Խʾ0
}

/*ڽ*/
void Protocol(void)
{
	int num1 = 0, num2 = 0;
	while (newLineReceived)  //Эݽһ
	{
			//жǷ51Э
			LED = 0;
		if(inputString[1] != '5' || inputString[2] != '1')
		{
		 	newLineReceived = 0;  
	   		memset(inputString, 0x00, sizeof(inputString)); 
			break; 
		}
		//жǷǷȵЭ
	 	if(inputString[4] != 'D' && inputString[5] != 'M' && inputString[6] != 'X')
		{
			newLineReceived = 0;  
	   		memset(inputString, 0x00, sizeof(inputString)); 
			break;
		}

		if(inputString[10] == '0') //
		{
			num1 = inputString[7]-0x30; //λ
			num2 = inputString[8]-0x30; //λ
			disp1[num1] &= ~( 1 << (7 - num2) );		
		}
		else if(inputString[10] == '1')	 //
		{
			num1 = inputString[7]-0x30; //λ
			num2 = inputString[8]-0x30; //λ
			disp1[num1] |= ( 1 << (7 - num2) );
		}
		else if(inputString[10] == '2') //
		{
			memset(disp1, 0x00, 8);			
		}
		else if(inputString[10] == '3') //ȫ
		{
			memset(disp1, 0xff, 8);			
		}

		newLineReceived = 0;  
   		memset(inputString, 0x00, sizeof(inputString)); 
	}
}

void main(void)
{
	uchar i;
	ComInit();
	Delay_xms(50);
	Init_MAX7219();  

	while(1)
	{
		for(i=1;i<9;i++)
			Write_Max7219(i,disp1[i-1]); 
	}
}

/******************************************************************/
/* жϳ*/
/******************************************************************/
void UART_SER () interrupt 4
{
	unsigned char n; 	//ʱ
	static int num = 0;

	if(RI) 		//жǽжϲ
	{
		RI = 0; 	//־λ
		n = SBUF; //뻺ֵ

		//control=n;
	    if(n == '$')
	    {
	      startBit = 1;
		  num = 0;
	    }
	    if(startBit == 1)
	    {
	       inputString[num] = n; 
		   num++;    
	    }  
	    if (n == '#') 
	    {
	       newLineReceived = 1; 
	       startBit = 0;
		   Protocol();
	    }
		
		if(num >= 50)
		{
			num = 0;
			startBit = 0;
			newLineReceived	= 0;
		}
	}

}
