/**********************BST-M51ʵ鿪************************
*  ƽ̨BST-M51 + Keil U4 + STC89C52
*  ƣӦʵ
*  ˾ǲ޹˾       
*  ڣ2015-6
*  :11.0592MHZ
******************************************************************/
#include<reg52.h>    //ƬĴͷļ
#include <intrins.h> 
#include <stdio.h>

#define  AddWr 0x90    //PCF8591 ַ

// 
unsigned char  D[2];

sbit scl=P2^1;       //I2C  ʱ 
sbit sda=P2^0;       //I2C   
sbit LED1 = P1^0;    //ƣ
sbit LED2 = P1^7;    //
bit ack;                 /*Ӧ־λ*/

unsigned char date;
unsigned int time_count=0;
bit flag=0;
/*******************************************************************
                     ߺ               
ԭ: void  Start_I2c();  
:     I2C,I2Cʼ.  
********************************************************************/
void Start_I2c()
{
  sda=1;         /*ʼź*/
  _nop_();
  scl=1;
  _nop_();        /*ʼʱ4.7us,ʱ*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();    
  sda=0;         /*ʼź*/
  _nop_();        /* ʼʱ4s*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();       
  scl=0;       /*ǯסI2Cߣ׼ͻ */
  _nop_();
  _nop_();
}

/*******************************************************************
                      ߺ               
ԭ: void  Stop_I2c();  
:     I2C,I2C.  
********************************************************************/
void Stop_I2c()
{
  sda=0;      /*ͽź*/
  _nop_();       /*ͽʱź*/
  scl=1;      /*ʱ4s*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();
  _nop_();
  sda=1;      /*I2C߽ź*/
  _nop_();
  _nop_();
  _nop_();
  _nop_();
}

/*******************************************************************
                 ֽݷͺ               
ԭ: void  I2C_SendByte(UCHAR c);
:     cͳȥ,ǵַ,Ҳ,ȴӦ,
          ״̬λв.(ӦӦʹack=0)     
           ack=1; ack=0ʾӦ𻵡
********************************************************************/
void  I2C_SendByte(unsigned char  c)
{
 unsigned char  i;
 
 for(i=0;i<8;i++)  /*Ҫ͵ݳΪ8λ*/
    {
     if((c<<i)&0x80)sda=1;   /*жϷλ*/
       else  sda=0;                
     _nop_();
     scl=1;               /*ʱΪߣ֪ͨʼλ*/
      _nop_(); 
      _nop_();             /*֤ʱӸߵƽڴ4s*/
      _nop_();
      _nop_();
      _nop_();         
     scl=0; 
    }
    
    _nop_();
    _nop_();
    sda=1;                /*8λͷߣ׼Ӧλ*/
    _nop_();
    _nop_();   
    scl=1;
    _nop_();
    _nop_();
    _nop_();
    if(sda==1)ack=0;     
       else ack=1;        /*жǷյӦź*/
    scl=0;
    _nop_();
    _nop_();
}

/*******************************************************************
                 ֽݽպ               
ԭ: UCHAR  I2C_RcvByte();
:        մ,жߴ(Ӧź)
          ӦӦӻ  
********************************************************************/    
unsigned char   I2C_RcvByte()
{
  unsigned char  retc=0,i; 
  sda=1;                     /*Ϊ뷽ʽ*/
  for(i=0;i<8;i++)
      {
        _nop_();           
        scl=0;                  /*ʱΪͣ׼λ*/
        _nop_();
        _nop_();                 /*ʱӵ͵ƽڴ4.7s*/
        _nop_();
        _nop_();
        _nop_();
        scl=1;                  /*ʱΪʹЧ*/
        _nop_();
        _nop_();
        retc=retc<<1;
        if(sda==1)retc=retc+1;  /*λ,յλretc */
        _nop_();
        _nop_(); 
      }
  scl=0;    
  _nop_();
  _nop_();
  return(retc);
}

/********************************************************************
                     ӦӺ
ԭ:  void Ack_I2c(bit a);
:      Ӧź(ӦӦźţλa)
********************************************************************/
void Ack_I2c(bit a)
{  
  if(a==0)sda=0;              /*ڴ˷ӦӦź */
  else sda=1;				  /*0ΪӦ1ΪӦź */
  _nop_();
  _nop_();
  _nop_();      
  scl=1;
  _nop_();
  _nop_();                    /*ʱӵ͵ƽڴ4s*/
  _nop_();
  _nop_();
  _nop_();  
  scl=0;                     /*ʱߣסI2CԱ*/
  _nop_();
  _nop_();    
}

/************************************************************
*         : Pcf8591_DaConversion
*       : PCF8591ģ
*           : addrַchannelתͨvalueתֵ
*          	: 
******************* *****************************************/
bit Pcf8591_DaConversion(unsigned char addr,unsigned char channel,  unsigned char Val)
{
   Start_I2c();              //
   I2C_SendByte(addr);            //ַ
   if(ack==0)return(0);
   I2C_SendByte(0x40|channel);              //Ϳֽ
   if(ack==0)return(0);
   I2C_SendByte(Val);            //DACֵ  
   if(ack==0)return(0);
   Stop_I2c();               //
   return(1);
}

/************************************************************
*         : Pcf8591_SendByte
* 		: дһ
*           : addrַchannelתͨ
*          	: 
************************************************************/
bit PCF8591_SendByte(unsigned char addr,unsigned char channel)
{
   Start_I2c();              //
   I2C_SendByte(addr);            //ַ
   if(ack==0)return(0);
   I2C_SendByte(0x40|channel);              //Ϳֽ
   if(ack==0)return(0);
   Stop_I2c();               //
   return(1);
}

/************************************************************
*        	: PCF8591_RcvByte
*    	: ȡһתֵ
*           :
*           : dat
************************************************************/
unsigned char PCF8591_RcvByte(unsigned char addr)
{  
   unsigned char dat;

   Start_I2c();          //
   I2C_SendByte(addr+1);      //ַ
   if(ack==0)return(0);
   dat=I2C_RcvByte();          //ȡ0

   Ack_I2c(1);           //ͷӦź
   Stop_I2c();           //
   return(dat);
}
/*------------------------------------------------
                 ڳʼ
------------------------------------------------*/
void init_com(void)
{
	TMOD|=0x20;		   //T0Ϊʽ1GATE=1
	SCON=0x50;
	TH1=0xFD;
	TL1=0xFD;
	TR1=1;			   //ʱ
	TI=1;
	EA=1;			   //ж

}

/*------------------------------------------------
                  ʱ
------------------------------------------------*/
void delay(unsigned char i)
{
  unsigned char j,k; 
  for(j=i;j>0;j--)
    for(k=125;k>0;k--);
}
/*------------------------------------------------
Ѷȡֵתһһַʾ
------------------------------------------------*/
void To_ascii(unsigned char num)
{	
	 SBUF=num/100+'0';		   	   
	 delay(200);		  
	 SBUF=num/10%10+'0';			   
	 delay(200);	
	 SBUF=num%10+'0';
	 delay(200);
}
/*------------------------------------------------
                    
------------------------------------------------*/
main()
{  
	unsigned char g_PHW = 0, g_VCS = 0;
	
	P1=0xff;
	init_com();
	while(1)
	{
		/********AD-DA*************/  
		PCF8591_SendByte(AddWr,1);
		D[0]=PCF8591_RcvByte(AddWr);
		/********½ADֵͨڷͳȥ****/
	 
	 	//⴫
		if(D[0] >= 150 && g_PHW != 1) //
		{
			g_PHW = 1;
			LED1 = 0;
			printf("$51,PHW1#\n");
		}
		else if(D[0] < 150 && g_PHW != 0)		 //
		{
			g_PHW = 0;
			LED1 = 1;
			printf("$51,PHW0#\n");
		}
		
		//
		if(D[0] < 180 && g_VCS != 1) //
		{
			g_VCS = 1;
			LED2 = 0;
			printf("$51,VCS1#\n");
		}
		else if(D[0] >= 180 && g_VCS != 0)		 //
		{
			g_VCS = 0;
			LED2 = 1;
			printf("$51,VCS0#\n");
		}
		 
//		delay(255);
//		delay(255);
//		delay(255);
//		delay(255);
//		delay(255);
//		delay(255);
//		delay(255);
//		delay(255);
		//printf("AD:%d\n", (int)D[0]);
    }
}
