
/**********************BST-V51ʵ鿪************************
*  ƽ̨BST-V51 + Keil U3 + STC89C52
*  ƣLCD1602ģʵ
*  ˾ǲܿƼ޹˾        
*  ڣ2013-11
*  :11.0592MHZ
*  ˵ѿԴṩԴ.
******************************************************************/
//ʵĿģ
/*-----------------------------------------------
  ƣLCD1602
  ݣͨ׼̬ʾַ
  Ŷ£1-VSS 2-VDD 3-V0 4-RS 5-R/W 6-E 7-14 DB0-DB7 15-BLA 16-BLK
------------------------------------------------*/
#include<reg52.h> //ͷļһҪĶͷļ⹦ܼĴĶ
#include<intrins.h>
#include<string.h>

#define uchar unsigned char

sbit RS = P1^0;   //˿ 
sbit RW = P1^1;
sbit EN = P2^5;
sbit DU = P2^0;
sbit WE = P2^1;

#define RS_CLR RS=0 
#define RS_SET RS=1

#define RW_CLR RW=0 
#define RW_SET RW=1 

#define EN_CLR EN=0
#define EN_SET EN=1

#define DataPort P0

/*Э鶨*/
bit startBit = 0;  				//ڽտʼ־λ
bit newLineReceived = 0; 		//һ֡Э
unsigned char inputString[50];  //Э
/*------------------------------------------------
                 ڳʼ
------------------------------------------------*/
void init_com(void)
{
	TMOD|=0x20;		   //T0Ϊʽ1GATE=1
	SCON=0x50;
	TH1=0xFD;
	TL1=0xFD;
	TR1=1;			   //ʱ
	//TI=1;
	EA=1;			   //ж
	ES=1;			   //жϴ
}


void cmg88()//ܣ
{
	DU=1;  
	P0=0X00;
	DU=0;
}
/*------------------------------------------------
 uSʱ unsigned char t޷ֵ
 unsigned char Ƕ޷ֵַķΧ
 0~255 ʹþ12Mȷʱʹû,ʱ
  T=tx2+5 uS 
------------------------------------------------*/
void DelayUs2x(unsigned char t)
{   
	while(--t);
}
/*------------------------------------------------
 mSʱ unsigned char t޷ֵ
 unsigned char Ƕ޷ֵַķΧ
 0~255 ʹþ12Mȷʱʹû
------------------------------------------------*/
void DelayMs(unsigned char t)
{
     
 while(t--)
 {
     //ʱ1mS
     DelayUs2x(245);
	 DelayUs2x(245);
 }
}
/*------------------------------------------------
              æ
------------------------------------------------*/
 bit LCD_Check_Busy(void) 
 { 
	 DataPort= 0xFF; 
	 RS_CLR; 
	 RW_SET; 
	 EN_CLR; 
	 _nop_(); 
	 EN_SET;
	 return (bit)(DataPort & 0x80);
 }
/*------------------------------------------------
              д
------------------------------------------------*/
 void LCD_Write_Com(unsigned char com) 
 {  
	 while(LCD_Check_Busy()); //æȴ
	 RS_CLR; 
	 RW_CLR; 
	 EN_SET; 		
	 DataPort= com; 
	 _nop_(); 
	 EN_CLR;
 }
/*------------------------------------------------
              дݺ
------------------------------------------------*/
 void LCD_Write_Data(unsigned char Data) 
 { 
	 while(LCD_Check_Busy()); //æȴ
	 RS_SET; 
	 RW_CLR; 
	 EN_SET; 
	 DataPort= Data; 
	 _nop_();
	 EN_CLR;
 }

/*------------------------------------------------
                
------------------------------------------------*/
 void LCD_Clear(void) 
 { 
	 LCD_Write_Com(0x01); 
	 DelayMs(5);
 }
/*------------------------------------------------
              дַ
------------------------------------------------*/
 void LCD_Write_String(unsigned char x,unsigned char y,unsigned char *s) 
 {     
	 if (y == 0) 
	 {     
		 LCD_Write_Com(0x80 + x);     //ʾһ
	 }
	 else 
	 {      
	 	LCD_Write_Com(0xC0 + x);      //ʾڶ
	 }        
	 while (*s) 
	 {     
		 LCD_Write_Data( *s);     
		 s ++;     
	 }
 }
/*------------------------------------------------
              дַ
------------------------------------------------*/
 void LCD_Write_Char(unsigned char x,unsigned char y,unsigned char Data) 
 {     
 	if (y == 0) 
 	{     
 		LCD_Write_Com(0x80 + x);     
 	}    
 	else 
 	{     
 		LCD_Write_Com(0xC0 + x);     
 	}        
 	LCD_Write_Data( Data);  
 }
/*------------------------------------------------
              ʼ
------------------------------------------------*/
void LCD_Init(void) 
{
   LCD_Write_Com(0x38);    /*ʾģʽ*/ 
   DelayMs(5); 
   LCD_Write_Com(0x38); 
   DelayMs(5); 
   LCD_Write_Com(0x38); 
   DelayMs(5); 
   LCD_Write_Com(0x38);  
   LCD_Write_Com(0x08);    /*ʾر*/ 
   LCD_Write_Com(0x01);    /*ʾ*/ 
   LCD_Write_Com(0x06);    /*ʾƶ*/ 
   DelayMs(5); 
   LCD_Write_Com(0x0C);    /*ʾ*/
}
   
/*------------------------------------------------
                    
------------------------------------------------*/ 
void main(void) 
{ 
	uchar temp[17] = {0};
	cmg88();//ܣ
	LCD_Init(); 
	LCD_Clear();//
	init_com();
	
	LCD_Write_Char(7,0,'o');
	LCD_Write_Char(8,0,'k');
	LCD_Write_String(1,1,"hello world");
	while (1) 
	{  
		//ʼЭ $51,LCD1602,1,0123456789abcdef# һ	 $51,LCD1602,2,0123456789abcdef# ڶ
		while (newLineReceived)  //Эݽһ
		{
			//жǷ51Э
			if(inputString[1] != '5' || inputString[2] != '1')
			{
			 	newLineReceived = 0;  
		   		memset(inputString, 0x00, sizeof(inputString)); 
				break; 
			}
			//жǷ1602Э
		 	if(inputString[4] != 'L' || inputString[5] != 'C' || inputString[6] != 'D'
			|| inputString[7] != '1'|| inputString[8] != '6'|| inputString[9] != '0'|| inputString[10] != '2')
			{
				newLineReceived = 0;  
	   			memset(inputString, 0x00, sizeof(inputString)); 
				break;	
			}
		
			//ʼȡ  λ12 ʼ  $51,HS00ff3003#
			if(inputString[12] == '0') //
			{
				LCD_Clear();//	
			}
			if(inputString[12] == '1') //ʾһ
			{
				memcpy(temp, inputString+14, 16);
				LCD_Write_String(0, 0, temp);
			}		
			if(inputString[12] == '2') //ʾڶ
			{
				memcpy(temp, inputString+14, 16);
				LCD_Write_String(0, 1, temp);
			}

		 	newLineReceived = 0;  
	   		memset(inputString, 0x00, sizeof(inputString)); 
			break;
		}
	
	}
}

/******************************************************************/
/* жϳ*/
/******************************************************************/
void UART_SER () interrupt 4
{
	unsigned char n; 	//ʱ
	static int num = 0;

	if(RI) 		//жǽжϲ
	{
		RI = 0; 	//־λ
		n = SBUF; //뻺ֵ

		//control=n;
	    if(n == '$')
	    {
	      startBit = 1;
		  num = 0;
	    }
	    if(startBit == 1)
	    {
	       inputString[num] = n; 
		   num++;    
	    }  
	    if (startBit == 1 && n == '#') 
	    {
	       newLineReceived = 1; 
	       startBit = 0;
		   num = 0;
	    }
		
		if(num >= 50)
		{
			num = 0;
			startBit = 0;
			newLineReceived	= 0;
		}
	}

}

